EA_Config = { DoAlertSound, AlertSound, AlertSoundValue, LockFrame, ShowFrame, ShowFlash, ShowTimer, Version, AllowESC };

function EventAlert_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

    this:RegisterEvent("PLAYER_LOGIN");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("VARIABLES_LOADED");
    this:RegisterEvent("PLAYER_DEAD");

    SlashCmdList["EVENTALERT"] = EventAlert_SlashHandler;
    SLASH_EVENTALERT1 = "/eventalert";
    SLASH_EVENTALERT2 = "/ea";
end


function EventAlert_OnEvent(event)

	if event == "VARIABLES_LOADED" then
        EventAlert_VersionCheck();

        if EA_Config.AlertSound == nil then EA_Config.AlertSound = "Sound\\Spells\\ShaysBell.wav" end;
        if EA_Config.AlertSoundValue == nil then EA_Config.AlertSoundValue = 1 end;
        if EA_Config.DoAlertSound == nil then EA_Config.DoAlertSound = true end;
		if EA_Config.LockFrame == nil then EA_Config.LockFrame = true end;
   		if EA_Config.ShowFrame == nil then EA_Config.ShowFrame = true end;
  		if EA_Config.ShowName == nil then EA_Config.ShowName = true end;
  		if EA_Config.ShowFlash == nil then EA_Config.ShowFlash = false end;
        if EA_Config.ShowTimer == nil then EA_Config.ShowTimer = true end;
        if EA_Config.IconSize == nil then EA_Config.IconSize = 60 end;
        if EA_Config.ChangeTimer == nil then EA_Config.ChangeTimer = false end;
        if EA_Config.AllowESC == nil then EA_Config.AllowESC = false end;

        if (EA_Position == nil) then
			EA_Position = { Anchor, relativePoint, xLoc, yLoc };

			if EA_Position.Anchor == nil then EA_Position.Anchor = "CENTER" end;
			if EA_Position.relativePoint == nil then EA_Position.relativePoint = "CENTER" end;
			if EA_Position.xLoc == nil then EA_Position.xLoc = 0 end;
			if EA_Position.yLoc == nil then EA_Position.yLoc = 0 end;
        end

		_, playerClass = UnitClass("player");
        EventAlert_LoadTextArray();
		EventAlert_LoadSpellArray();
        EventAlert_Options_Init();
        EventAlert_CreateFrames();

        EA_TempBuffsTable = { };
	end

	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then

		local eventType = arg2;

        if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_APPLIED_DOSE") then
        	if (arg7 == UnitName("player")) then
	        	if (arg9 ~= 53817) then
					if (EA_Items[playerClass][arg9] or EA_Items["Other"][arg9]) then

                        table.insert(EA_TempBuffsTable, arg9);
						EventAlert_PositionFrames();
						EventAlert_DoAlert();
                    end

	        	elseif (arg9 == 53817) then
	            	if (arg13 == 5) then

                        table.insert(EA_TempBuffsTable, arg9);
						EventAlert_PositionFrames();
                        EventAlert_DoAlert();
	                end
	            end
    	   	end
	    end

        if(eventType == "SPELL_AURA_REMOVED" and arg7 == UnitName("player")) then
			if (EA_Items[playerClass][arg9] or EA_Items["Other"][arg9]) then
				local v = table.foreach(EA_TempBuffsTable, function(i, v) if v==arg9 then return v end end)
					if v then
                    	local f = _G["EAFrame_"..v];
	                    f:Hide();
				    	removeBuffValue(EA_TempBuffsTable, v);
						EventAlert_PositionFrames();
	                end
			end
		end

    	if(event == "PLAYER_DEAD" or event == "PLAYER_ENTERING_WORLD") then
			local v = table.foreach(EA_TempBuffsTable, function(i, v) if v==arg9 then return v end end)
			   if v then
	           		local f = _G["EAFrame_"..v];
	                f:Hide();
					EA_TempBuffsTable = table.wipe(EA_TempBuffsTable);
				end
	    end
    end
end


function EventAlert_CreateFrames()


        local anchorFrameName = "EA_Anchor_Frame";

        if (EA_Config.AllowESC == true) then
	        tinsert(UISpecialFrames,anchorFrameName);
        end

        local eaaf = CreateFrame("FRAME", anchorFrameName, UIParent);

        eaaf:SetFrameStrata("DIALOG");
        eaaf:ClearAllPoints();
        eaaf:SetPoint(EA_Position.Anchor, UIParent, EA_Position.xLoc, EA_Position.yLoc);

		eaaf.spellName = eaaf:CreateFontString(anchorFrameName.."_Name","OVERLAY");
		eaaf.spellName:SetFontObject(ChatFontNormal);
		eaaf.spellName:SetPoint("BOTTOM", 0, -15);

		eaaf.spellTimer = eaaf:CreateFontString(anchorFrameName.."_Timer","OVERLAY");
		eaaf.spellTimer:SetFontObject(ChatFontNormal);
		eaaf.spellTimer:SetPoint("TOP", 0, 15);

  		eaaf:SetBackdrop({bgFile = "Interface/Icons/Spell_Nature_Polymorph_Cow"});

		eaaf:SetMovable(true)
		eaaf:EnableMouse(true)
		eaaf:SetScript("OnMouseDown",function()
			if (EA_Config.LockFrame == true) then
	    		DEFAULT_CHAT_FRAME:AddMessage("EventAlert: You must unlock the alert frame in order to move it or reset it's position.")
			else
        	    eaaf:StartMoving();
            end
		end)
		eaaf:SetScript("OnMouseUp",function()
			eaaf:StopMovingOrSizing();

            local point, _, relativePoint, xOfs, yOfs = EA_Anchor_Frame:GetPoint();

	        EA_Position.Anchor = point;
            EA_Position.relativePoint = relativePoint;
            EA_Position.xLoc = xOfs;
			EA_Position.yLoc = yOfs;
		end)


	for index,value in pairsByKeys(EA_Items[playerClass]) do
		if (type(value) == "number") then
			value = tostring(index)
		elseif (type(value) == "boolean") then
			if (value) then
				value = "true"
		    else
			    value = "false"
		    end
		end

        local eaf = CreateFrame("FRAME", "EAFrame_"..index, EA_Main_Frame);

        if (EA_Config.AllowESC == true) then
	        tinsert(UISpecialFrames,"EAFrame_"..index);
        end

        eaf:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	    eaf:RegisterEvent("PLAYER_LOGIN");
	    eaf:RegisterEvent("VARIABLES_LOADED");
	    eaf:RegisterEvent("PLAYER_DEAD");

        eaf:SetFrameStrata("DIALOG");

		eaf.spellName = eaf:CreateFontString("EAFrame_"..index.."_Name","OVERLAY");
		eaf.spellName:SetFontObject(ChatFontNormal);
		eaf.spellName:SetPoint("BOTTOM", 0, -15);

		eaf.spellTimer = eaf:CreateFontString("EAFrame_"..index.."_Timer","OVERLAY");
		eaf.spellTimer:SetFontObject(ChatFontNormal);
		eaf.spellTimer:SetPoint("TOP", 0, 15);

        eaf:SetScript("OnEvent", EventAlert_OnEvent);
        eaf:SetScript("OnUpdate", EventAlert_OnUpdate);
    end
end


function EventAlert_OnUpdate()
local timerFontSize = 0;

    for i,v in ipairs (EA_TempBuffsTable) do
		local eaf = _G["EAFrame_"..v];

		if (EA_Config.ShowTimer == true) then
		    local name, rank = GetSpellInfo(v);
			local _,_,_,_,_,_,expirationTime,_,_ = UnitAura("player", name, rank)

			if not expirationTime then
		    	return
		    end

			local time = 0;

			time = time + expirationTime;
			currentTime = GetTime();
			timeLeft = expirationTime - currentTime;


		    if timeLeft > 0 then
				if (EA_Config.ChangeTimer == true) then
	               timerFontSize = 28;
	               eaf.spellTimer:ClearAllPoints();
	               eaf.spellTimer:SetPoint("CENTER", 0, 0);
	        	else
	            	timerFontSize = 18;
	                eaf.spellTimer:ClearAllPoints();
	                eaf.spellTimer:SetPoint("TOP", 0, 20);
	            end

	            eaf.spellTimer:SetFont("Fonts\\\FRIZQT__.TTF", timerFontSize, "OUTLINE");
	            eaf.spellTimer:SetFormattedText("%d", timeLeft);
			end
		end
    end

end


function EventAlert_DoAlert()

	if (EA_Config.ShowFlash == true) then
	   UIFrameFadeIn(LowHealthFrame, 1, 0, 1);
	   UIFrameFadeOut(LowHealthFrame, 2, 1, 0);
	end

	if (EA_Config.DoAlertSound == true) then
	   PlaySoundFile(EA_Config.AlertSound);
	end
end


function EventAlert_PositionFrames(event)

	if (EA_Config.ShowFrame == true) then

    	EA_Main_Frame:ClearAllPoints();
   		EA_Main_Frame:SetPoint(EA_Position.Anchor, UIParent, EA_Position.relativePoint, EA_Position.xLoc, EA_Position.yLoc);

		local prevFrame = "EA_Main_Frame";

        for k,v in ipairs(EA_TempBuffsTable) do
		   	local eaf = _G["EAFrame_"..v];

            if (v == 48517) then
            	_, _, gsiIcon, _, _, _, _, _, _ = GetSpellInfo(5176);
				gsiName, _, _, _, _, _, _, _, _ = GetSpellInfo(v);
            elseif (v == 48518) then
				_, _, gsiIcon, _, _, _, _, _, _ = GetSpellInfo(2912);
				gsiName, _, _, _, _, _, _, _, _ = GetSpellInfo(v);
            else
				gsiName, _, gsiIcon, _, _, _, _, _, _ = GetSpellInfo(v);
            end

        	eaf:ClearAllPoints();

            if (prevFrame == "EA_Main_Frame") then
				eaf:SetPoint("CENTER", prevFrame, "CENTER", 0, 0);
            else
            	eaf:SetPoint("CENTER", prevFrame, "CENTER", 100, 0);
            end

            eaf:SetWidth(EA_Config.IconSize);
			eaf:SetHeight(EA_Config.IconSize);

			eaf:SetBackdrop({bgFile = gsiIcon});


            if (EA_Config.ShowName == true) then
	    		eaf.spellName:SetText(gsiName);
		    else
	    		eaf.spellName:SetText("");
			end

            prevFrame = eaf;
	    	eaf:Show();
        end
	end
end


function EventAlert_SlashHandler(msg)

    msg = string.lower(msg);

	if (msg == "options" or msg == "opt") then

    	if not EA_Options_Frame:IsVisible() then
            ShowUIPanel(EA_Options_Frame);
	    else
	        HideUIPanel(EA_Options_Frame);
	    end
    elseif (msg == "version" or msg == "ver") then
        DEFAULT_CHAT_FRAME:AddMessage("EventAlert version: "..EA_Config.Version);
    else
        DEFAULT_CHAT_FRAME:AddMessage("EventAlert commands (/eventalert or /ea):");
        DEFAULT_CHAT_FRAME:AddMessage("/ea options (/ea opt) - Toggle the options window on or off");
        DEFAULT_CHAT_FRAME:AddMessage("/ea version (/ea ver) - Shows the current version of EventAlert.");
    end

end


function removeBuffValue(tab, value)
	for pos, name in ipairs(tab) do
		if (name == value) then
			table.remove(tab, pos)
		end
	end
end

function pairsByKeys (t, f)
	local a = {}
		for n in pairs(t) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], t[a[i]]
			end
		end
	return iter
end


function EventAlert_VersionCheck()

    if (EA_Config.Version == "4.0.4") then
    	-- Do Nothing

	elseif (EA_Config.Version == "4.0.3" or EA_Config.Version == "4.0.2") then
		EA_Config.Version = "4.0.4";

    elseif (EA_Config.Version == "4.0.1") then
    	EA_Config.Version = "4.0.4";
		EA_Version_Frame_EditBox:SetFontObject(ChatFontNormal);
		EA_Version_Frame_EditBox:SetText("- EventAlert new version detected.\n\n\nKnown Bugs:\n          * Anchor button has to be pressed twice for it to show.\n\nI *HOPE* that is the only bug ATM.\n\n\nVersion 4.0.1 had a bug where Pallies would get alerts on Holy Shield and Shadow Resist Aura.  Those are the skills I use to test the mod, and I forgot to remove them before uploading.  Sorry Pallies.  Should be fixed now!\n\n\nEventAlert version "..EA_Config.Version.." loaded.")

	    EA_Version_Frame:Show();

		EA_Items[EA_CLASS_PALADIN][27179] = nil;
		EA_Items[EA_CLASS_PALADIN][27151] = nil;

    elseif (EA_Config.Version == nil) then
    	EA_Config.Version = "4.0.4";
		EA_Version_Frame_EditBox:SetFontObject(ChatFontNormal);
		EA_Version_Frame_EditBox:SetText("- EventAlert first load detected.\n- EventAlert is setting all settings to default.\n\nKnown Bugs:\n          * Anchor button has to be pressed twice for it to show.\n\n\nEventAlert version "..EA_Config.Version.." loaded.")

		EA_Version_Frame:Show();

		EventAlert_FunctionOfDoom();
    end
end


-- THE CAKE IS A LIE!
function EventAlert_FunctionOfDoom()
	EA_Config = nil;
	EA_Config = { DoAlertSound, AlertSound, AlertSoundValue, LockFrame, ShowFrame, ShowFlash, ShowTimer, Version, AllowESC };
    EA_Config.Version = "4.0.3";

    EA_Position = nil;
	EA_Items = nil;
end